#!/bin/sh

# Prettify ls commands
if [ "$(uname -s)" = "Linux" ]; then
  # we're on linux
  alias l-d="ls -lFad"
  alias l="ls -lAhF" # Overwritten for k in -aliasing-k
  alias ll="ls -lFa | TERM=vt100 less"
  alias ls='ls --color=auto'
fi

# Show the top 5 commands used in recent history
_zhtop() {
  history | awk "{a[\$2]++} END{for(i in a){printf \"%5d\t%s\n\",a[i],i}}" | sort -rn | head
}
alias zhtop=_zhtop
# Display timestamped recent command history
alias zh="fc -l -d -D"

# Display your current ip address
alias myip="curl -s icanhazip.com"

# move around faster for often used cd commands
alias ..="cd .." # overwritten by enhancd config in .zshrc.d/
alias ...="cd ../.."
alias ~="cd ~"

# make v call vim
alias v="vim"

# short, consise, clear my screen
alias cl="clear"

# let me exit out of the shell same way as vim
# TODO integrate session management with w?
alias :q="exit"
alias :wq="exit"
