#!/bin/sh

# enables git management through dot command
alias dot='/usr/bin/git --git-dir=/home/marty/.dotfiles/ --work-tree=/home/marty'

# The following commands are run on your git repo if you installed through the script
# You can invoke them manually, but it's not recommended to keep them active in here.
# Otherwise each time a shell starts up, *whatever directory you are in*, the commands
# will be re-run.
#
## Make git assume the readme is not changing (essentially ignore it).
#
# This means you can safely remove the README.md file from your home dir
# without git trying to delete it from the repository.
# If you WANT to make changes to the README.md, you will have to make git
# watch it again with the commented out command
#
# Read more: https://stackoverflow.com/questions/4308610/how-to-ignore-certain-files-in-git
# and: https://stackoverflow.com/questions/653454/how-do-you-make-git-ignore-files-without-using-gitignore
#
#dot update-index --no-assume-unchanged README.md
#dot update-index --assume-unchanged README.md

## Make git not show untracked files (i.e. ALL other files in your home dir)
#dot config status.showUntrackedFiles no
