#!/bin/zsh
#
# Clone tmux plugin manager if not existing
if [[ -z "$TPM_PARENT_DIR" ]]; then
  TPM_PARENT_DIR=${XDG_CONFIG_HOME:-$HOME/.config}/tmux
fi

if [[ ! -f $TPM_PARENT_DIR/plugins/tpm/tpm ]]; then
  if [[ ! -d "$TPM_PARENT_DIR" ]]; then
    mkdir -p "$TPM_PARENT_DIR"
  fi
  cd "$TPM_PARENT_DIR" || exit
  git clone https://github.com/tmux-plugins/tpm plugins/tpm
fi

export TMUX_PLUGIN_MANAGER_PATH=$TPM_PARENT_DIR/plugins
alias tmux="tmux -f "'"${TPM_PARENT_DIR}"'"/tmux.conf"

unset TPM_PARENT_DIR
unset TPM_SUB_DIR
